unit hiGP_ArrayXY;

interface

uses Windows,Kol,Share,Debug;

type
  THIGP_ArrayXY = class(TDebug)
   private
     FPoints:PList; 
     Arr:PArray;
     procedure SetPoints(Value:string);
     procedure _Set(var Item:TData; var Val:TData);
     function _Get(Var Item:TData; var Val:TData):boolean;
     function _Count:integer;
     procedure _Add(var Val:TData);
   public
    _prop_FileName:string;
    _prop_Delimiter: string;

    _data_FileName:THI_Event;
    _event_onChange:THI_Event;
    
    constructor Create;
    destructor Destroy; override;
    procedure ClearPointsArray;
    procedure _work_doLoad(var _Data:TData; Index:word);
    procedure _work_doSave(var _Data:TData; Index:word);
    procedure _work_doClear(var _Data:TData; Index:word);
    procedure _var_ArrayXY(var _Data:TData; Index:word);
    procedure _var_Count(var _Data:TData; Index:word);
    property _prop_PointsXY:string write SetPoints;
  end;

implementation

constructor THIGP_ArrayXY.Create;
begin
   inherited Create;
   FPoints := NewList;
end;

destructor THIGP_ArrayXY.Destroy;
begin
   ClearPointsArray;
   FPoints.Free;
   if Arr <> nil then dispose(Arr);
   inherited Destroy;
end;

procedure THIGP_ArrayXY.ClearPointsArray;
var i:integer;
begin
   if FPoints.Count > 0 then
     for i := 0 to FPoints.Count-1 do begin 
       FreeData(PData(FPoints.Items[i]));
       dispose(PData(FPoints.Items[i]));
     end;
end;

procedure THIGP_ArrayXY.SetPoints;
var TempList: PStrList;
    i:integer;
    x,y:single;
    str:string;
    d:PData;
    dt,di: TData;
begin
   TempList := NewStrList;
   TempList.SetText(Value, false);
   if TempList.Count > 0 then begin
    for i := 0 to TempList.Count - 1 do begin
     dtNull(dt);
     dtNull(di);
     str := TempList.Items[i];
     x := str2Double(GetTok(str,';'));
     y := str2Double(str);
     dtReal(di, x);
     AddMTData(@dt, @di, d);
     dtReal(di, y);
     AddMTData(@dt, @di, d);
     _Add(dt);
    end;
    FreeData(@di);
    FreeData(@dt);
   end;
   TempList.Free;
end;

procedure THIGP_ArrayXY._work_doLoad;
var TempList: PStrList;
    fn,str:string;
    x,y:single;
    i:integer;
    d:PData;
    dt,di: TData;
begin
   fn := ReadString(_Data,_data_FileName,_prop_FileName);
   if FileExists(fn) then begin
     ClearPointsArray;
     FPoints.Clear;
     TempList := NewStrList;
     TempList.LoadFromFile(fn);
     if TempList.Count > 0 then begin
       for i := 0 to TempList.Count - 1 do begin
         dtNull(dt);
         dtNull(di);
	     str := TempList.Items[i];
	     x := str2Double(GetTok(str, _prop_Delimiter[1]));
	     y := str2Double(str);
	     dtReal(di, x);
         AddMTData(@dt, @di, d);
         dtReal(di, y);
         AddMTData(@dt, @di, d);
         _Add(dt);
	   end; 
       _hi_CreateEvent(_Data, @_event_onChange);
	 end;
     FreeData(@di);
     FreeData(@dt);
	 TempList.Free;	  	 
   end;   
end;

procedure THIGP_ArrayXY._work_doSave;
var  TempList: PStrList; 
     fn,str:string;
     i:integer;
     d:PData;
     dt:TData; 
begin
   fn := ReadString(_Data,_data_FileName,_prop_FileName);
   if FPoints.Count > 0 then begin
    TempList := NewStrList;
    for i := 0 to FPoints.Count - 1 do begin
      dtNull(dt);
      d := FPoints.Items[i];  
      dtData(dt, d^);
      d := d.ldata; 
      str := Double2str(toReal(dt));//X
      dtData(dt, d^);
      str := str + _prop_Delimiter[1] + Double2str(toReal(dt));
      TempList.Add(str);
    end;
    FreeData(@dt);
    TempList.SaveToFile(fn);
    TempList.Free;
   end;
end;

procedure THIGP_ArrayXY._work_doClear;
begin
   ClearPointsArray;
   FPoints.Clear;
   _hi_CreateEvent(_Data, @_event_onChange);
end;

procedure THIGP_ArrayXY._Set;
var   ind:integer;
begin
   ind := ToIntIndex(Item);
   if(ind >= 0)and(ind < _Count)then begin
      FreeData(PData(FPoints.Items[ind]));
      CopyData(PData(FPoints.Items[ind]),@Val);
      FreeData(@Val);
   end;
end;

procedure THIGP_ArrayXY._Add;
var   dt:PData;
begin
   new(dt);
   CopyData(dt,@Val);
   FreeData(@Val);
   FPoints.Add(dt);
end;

function THIGP_ArrayXY._Get;
var   ind:integer;
begin
   ind := ToIntIndex(Item);
   if(ind >= 0)and(ind < _Count)then begin
      Result := true;
      FreeData(@Val);
      dtNull(Val);
      CopyData(@Val, PData(FPoints.Items[ind]));
   end
   else Result := false;
end;

function THIGP_ArrayXY._Count;
begin
   Result := FPoints.Count;
end;

procedure THIGP_ArrayXY._var_ArrayXY;
begin
   if Arr = nil then Arr := CreateArray(_Set, _Get, _Count, _Add);
   dtArray(_Data,Arr);
end;

procedure THIGP_ArrayXY._var_Count;
begin
  dtInteger(_Data,FPoints.Count);
end;

end.