unit hiGP_Bezier;

interface

uses Kol,Share,Debug,hiGP_Canvas,GDIPOBJ,GDIPAPI;

type
  THIGP_Bezier = class(TDebug)
   private
     Item:TData;
     FPoints:PStrList; 
     points: array of TGPPointF;
     procedure WritePoints;
     procedure SetPoints(Value:string);
   public
     _prop_Canvas:PICurrentCanvas;
     _prop_X1:single;
     _prop_Y1:single;
     _prop_X2:single;
     _prop_Y2:single;
     _prop_X3:single;
     _prop_Y3:single;
     _prop_X4:single;
     _prop_Y4:single;
     _prop_Pen:string;

     _data_PointsArray:THI_Event;               
     _data_X1:THI_Event;
     _data_Y1:THI_Event;     
     _data_X2:THI_Event;
     _data_Y2:THI_Event;
     _data_X3:THI_Event;
     _data_Y3:THI_Event;     
     _data_X4:THI_Event;
     _data_Y4:THI_Event;
     _data_Pen:THI_Event;
     _event_onDraw: THI_Event;
     
	 constructor Create;
     destructor Destroy; override;    
     property _prop_PointsArray:string write SetPoints;
     procedure _work_doDraw(var _Data:TData; Index:word);
  end;

implementation


constructor THIGP_Bezier.Create;
begin
   inherited Create;
   FPoints := NewStrList;
end;

destructor THIGP_Bezier.Destroy;
begin
   FPoints.Free;
   inherited Destroy;
end;

procedure THIGP_Bezier.WritePoints;
var str: string;
    i:integer;
begin
   SetLength(Points, FPoints.Count);
   for i := 0 to FPoints.Count - 1 do begin
    str := FPoints.Items[i];
     points[i].X := str2Double(GetTok(str,';'));
     points[i].Y := str2Double(GetTok(str,';'));
   end;
end;

procedure THIGP_Bezier.SetPoints;
begin
   FPoints.SetText(Value, false);
   WritePoints;
end;

procedure THIGP_Bezier._work_doDraw;
var iPen:string;
    i:integer;
    Arr:PArray;
    Ind,dt:TData;
    d:PData;
    x1,y1,x2,y2,x3,y3,x4,y4:single;
    Graphics:TGPGraphics;
begin
   if not Assigned(_prop_Canvas) then exit;
   Graphics := _prop_Canvas.Get_Canvas;
   Arr := ReadArray(_data_PointsArray);
   if (Arr <> nil) and (Arr._Count > 0)then begin
     SetLength(Points, Arr._Count); 
     for i := 0 to Arr._Count - 1 do begin
       dtInteger(Ind,i);
       Arr._Get(Ind,Item);
       d := @Item;  
       dtData(dt, d^);
       d := d.ldata; 
       points[i].X := toReal(dt);
       dtData(dt, d^);
       points[i].Y := toReal(dt);
     end;
     FreeData(@Item);
   end;
   if Length(points) > 0 then begin 
     iPen := ReadString(_data,_data_Pen,_prop_Pen);
     Graphics.DrawBeziers(_prop_Canvas.Get_Pen(iPen),PGPPointF(points),Length(points)); 
   end else begin
     x1 := ReadReal(_data,_data_X1,_prop_X1);
     y1 := ReadReal(_data,_data_Y1,_prop_Y1); 
     x2 := ReadReal(_data,_data_X2,_prop_X2);
     y2 := ReadReal(_data,_data_Y2,_prop_Y2);
     x3 := ReadReal(_data,_data_X3,_prop_X3);
     y3 := ReadReal(_data,_data_Y3,_prop_Y3); 
     x4 := ReadReal(_data,_data_X4,_prop_X4);
     y4 := ReadReal(_data,_data_Y4,_prop_Y4);
     iPen := ReadString(_data,_data_Pen,_prop_Pen);
     Graphics.DrawBezier(_prop_Canvas.Get_Pen(iPen),x1,y1,x2,y2,x3,y3,x4,y4);   
   end; 
   _hi_CreateEvent(_Data,@_event_onDraw);
end;

end.