unit hiGP_BrushGradient;

interface

uses Windows,Kol,Share,Debug,hiGP_Canvas,GDIPOBJ,GDIPAPI;

type
  THIGP_BrushGradient= class(TDebug)
   private
   public
     _prop_Index: string;
     _prop_Canvas:PICurrentCanvas;
     _prop_Color: integer;
     _prop_Color2: integer;
     _prop_Alpha:integer;
     _prop_Alpha2:integer;
     _prop_X:integer;
     _prop_Y:integer;
     _prop_Width:integer;
     _prop_Hieght:integer;
     _prop_Mode:integer;
     _prop_UseMatrix:boolean;
          
     _data_Color:THI_Event;          
     _data_Color2:THI_Event;   
     _data_Alpha:THI_Event;
     _data_Alpha2:THI_Event;
     _data_X:THI_Event;          
     _data_Y:THI_Event;
     _data_Width:THI_Event;
     _data_Hieght:THI_Event;
     _data_Mode:THI_Event;
     _data_Index:THI_Event; 
     _event_onSet: THI_Event;

     procedure _work_doSet(var _Data:TData; Index:word);
  end;

implementation

procedure THIGP_BrushGradient._work_doSet;
var   iBrush:string;
      fFrom1, fFrom2: TRGB;
      md,a1,a2,x,y,w,h:integer;
      GradientBrush: TGPLinearGradientBrush;
      GPMatrix: TGPMatrix;
begin
    if not Assigned(_prop_Canvas) then exit;
    iBrush := ReadString(_data,_data_Index,_prop_Index);
    fFrom1 := TRGB(Color2RGB(ReadInteger(_Data, _data_Color, _prop_Color)));
    a1 := ReadInteger(_data,_data_Alpha,_prop_Alpha);
    fFrom2 := TRGB(Color2RGB(ReadInteger(_Data, _data_Color2, _prop_Color2)));
    a2 := ReadInteger(_data,_data_Alpha2,_prop_Alpha2);
    x := ReadInteger(_data,_data_X,_prop_X);
    y := ReadInteger(_data,_data_Y,_prop_Y);
    w := ReadInteger(_data,_data_Width,_prop_Width);
    h := ReadInteger(_data,_data_Hieght,_prop_Hieght);  
    md := ReadInteger(_data,_data_Mode,_prop_Mode);
    GradientBrush := TGPLinearGradientBrush.Create(MakeRect(x,y,w,h),
     MakeColor(a1, FFrom1.R, FFrom1.G, FFrom1.B),
      MakeColor(a2, FFrom2.R, FFrom2.G, FFrom2.B),
       TLinearGradientMode(md));
    if _prop_UseMatrix then begin
     GPMatrix := _prop_Canvas.Get_Matrix;
	 GradientBrush.SetTransform(GPMatrix); 
     GPMatrix.Reset;
    end;
    _prop_Canvas.Set_Brush(GradientBrush.Clone,iBrush); 
    GradientBrush.Free;
    _hi_CreateEvent(_Data,@_event_onSet);
end;

end.