unit hiGP_BrushGradientPath;

interface

uses Windows,Kol,Share,Debug,hiGP_Canvas,GDIPOBJ,GDIPAPI;

type
  THIGP_BrushGradientPath= class(TDebug)
   private
     FPoints:PStrList; 
     FColors:PStrList; 
     Points: array of TGPPointF;
     Colors: array of TGPColor;
     procedure SetPoints(Value:string);
     procedure SetColors(Value:string);
   public
     _prop_Index: string;
     _prop_Canvas:PICurrentCanvas;
     _prop_Color: integer;
     _prop_Alpha:integer;
     _prop_ChangeCenter:boolean;
     _prop_X:real;
     _prop_Y:real;
     _prop_UseMatrix:boolean;

     _data_Color:THI_Event;          
     _data_Alpha:THI_Event;
     _data_X:THI_Event;          
     _data_Y:THI_Event;
     _data_Index:THI_Event; 
     _event_onCreate: THI_Event;

     constructor Create;
     destructor Destroy; override;   
     procedure _work_doCreate(var _Data:TData; Index:word);
     property _prop_PointsArray:string write SetPoints;
     property _prop_ColorsArray:string write SetColors;
  end;

implementation

constructor THIGP_BrushGradientPath.Create;
begin
   inherited Create;
   FPoints := NewStrList;
   FColors := NewStrList;
end;

destructor THIGP_BrushGradientPath.Destroy;
begin
   FPoints.Free;
   FColors.Free;
   inherited Destroy;
end;

procedure THIGP_BrushGradientPath.SetPoints;
var str: string;
    i:integer;
begin
   FPoints.SetText(Value, false);
   SetLength(Points, FPoints.Count);
   for i := 0 to FPoints.Count - 1 do begin
    str := FPoints.Items[i];
     Points[i].X := str2Double(GetTok(str,';'));
     Points[i].Y := str2Double(GetTok(str,';'));
   end;
end;

procedure THIGP_BrushGradientPath.SetColors;
var str: string;
    alpha,i:integer;
    fFrom:TRGB;
begin
   FColors.SetText(Value, false);
   SetLength(Colors, FColors.Count);
   for i := 0 to FColors.Count - 1 do begin
    str := FColors.Items[i];
     fFrom := TRGB(Color2RGB(str2int(GetTok(str,';'))));
     alpha := str2int(GetTok(str,';'));
     Colors[i] := MakeColor(alpha, FFrom.R, FFrom.G, FFrom.B);
   end;
end;

procedure THIGP_BrushGradientPath._work_doCreate;
var   iBrush:string;
      fFrom: TRGB;
      num,a: integer;
      x,y:single;
      GradientBrush: TGPPathGradientBrush;
      GPMatrix: TGPMatrix;
begin
    iBrush := ReadString(_data,_data_Index,_prop_Index);
    GradientBrush := TGPPathGradientBrush.Create(PGPPointF(Points),Length(Points));
    num := Length(Colors);
    GradientBrush.SetSurroundColors(pARGB(Colors),num);
    fFrom := TRGB(Color2RGB(ReadInteger(_Data, _data_Color, _prop_Color)));
    a := ReadInteger(_data,_data_Alpha,_prop_Alpha);
    GradientBrush.SetCenterColor(MakeColor(a, FFrom.R, FFrom.G, FFrom.B));
    if _prop_ChangeCenter then begin
     x := ReadReal(_data,_data_X,_prop_X);
     y := ReadReal(_data,_data_Y,_prop_Y);
     GradientBrush.SetCenterPoint(MakePoint(x,y));
    end;
    if _prop_UseMatrix then begin
     GradientBrush.SetTransform(_prop_Canvas.Get_Matrix); 
     GPMatrix := _prop_Canvas.Get_Matrix;
	 GPMatrix.Reset;
    end;
    _prop_Canvas.Set_Brush(GradientBrush.Clone,iBrush); 
    GradientBrush.Free;
    _hi_CreateEvent(_Data,@_event_onCreate);
end;

end.