unit hiGP_Curve;

interface

uses Kol,Share,Debug,hiGP_Canvas,GDIPOBJ,GDIPAPI;

type
  THIGP_Curve = class(TDebug)
   private
     Item:TData;
     FPoints:PStrList; 
     Points: array of TGPPointF;
     procedure SetPoints(Value:string);
   public
     _prop_Canvas:PICurrentCanvas;
     _prop_Tension:single;
     _prop_Type:integer;
     _prop_FillMode:integer;
     _prop_AllSegments:boolean;
     _prop_View:integer;
     _prop_Pen:string;
     _prop_Brush:string;
                         
     _data_ArrayXY:THI_Event;
     _data_Tension:THI_Event;     
     _data_StartSegments:THI_Event;
     _data_NumberSegments:THI_Event;
     _data_Pen:THI_Event;
     _data_Brush:THI_Event;
     _event_onDraw: THI_Event;
     
     constructor Create;
     destructor Destroy; override;    
     property _prop_PointsArray:string write SetPoints;
     procedure _work_doDraw(var _Data:TData; Index:word);
     procedure _work_doType(var _Data:TData; Index:word);
     procedure _work_doFillMode(var _Data:TData; Index:word);
  end;

implementation

constructor THIGP_Curve.Create;
begin
   inherited Create;
   FPoints := NewStrList;
end;

destructor THIGP_Curve.Destroy;
begin
   FPoints.Free;
   inherited Destroy;
end;

procedure THIGP_Curve.SetPoints;
var str: string;
    i:integer;
begin
   FPoints.SetText(Value, false);
   SetLength(points, FPoints.Count);
   for i := 0 to FPoints.Count - 1 do begin
    str := FPoints.Items[i];
     points[i].X := str2Double(GetTok(str,';'));
     points[i].Y := str2Double(GetTok(str,';'));
   end;
end;

procedure THIGP_Curve._work_doDraw;
var  tens: single;
     i,count,first,last: integer;
     iPen,iBrush: string;
     Arr: PArray;
     Ind,dt: TData;
     d: PData;
     Graphics:TGPGraphics;
begin
   if not Assigned(_prop_Canvas) then exit;
   Graphics := _prop_Canvas.Get_Canvas;
   Arr := ReadArray(_data_ArrayXY);
   if (Arr <> nil) and (Arr._Count > 0)then begin
    SetLength(points, Arr._Count); 
    for i := 0 to Arr._Count - 1 do begin
     dtInteger(Ind,i);
     Arr._Get(Ind,Item);
     d := @Item;  
     dtData(dt, d^);
     d := d.ldata; 
     points[i].X := toReal(dt);
     dtData(dt, d^);
     points[i].Y := toReal(dt);
    end;
    FreeData(@Item);
   end else
   SetLength(points, 0);
   
   tens := ReadReal(_data,_data_Tension,_prop_Tension);
   count := Length(points);
   if _prop_AllSegments then begin
    first := 0;
    last := count - 1;
   end else begin
    first := ReadInteger(_data,_data_StartSegments);
    last := ReadInteger(_data,_data_NumberSegments);
   end; 
    iPen := ReadString(_data,_data_Pen,_prop_Pen);
    iBrush := ReadString(_data,_data_Brush,_prop_Brush);
   case _prop_Type of
    0: Graphics.DrawCurve(_prop_Canvas.Get_Pen(iPen),PGPPointF(points),count,first,last,tens);
    1: Graphics.DrawClosedCurve(_prop_Canvas.Get_Pen(iPen),PGPPointF(points),count,tens);
    2: Graphics.FillClosedCurve(_prop_Canvas.Get_Brush(iBrush),PGPPointF(points),count,FillMode(_prop_FillMode),tens);
    3: begin 
        Graphics.FillClosedCurve(_prop_Canvas.Get_Brush(iBrush),PGPPointF(points),count,FillMode(_prop_FillMode),tens);
        Graphics.DrawClosedCurve(_prop_Canvas.Get_Pen(iPen),PGPPointF(points),count,tens); 
       end;
    end;
   _hi_CreateEvent(_Data,@_event_onDraw);
end;

procedure THIGP_Curve._work_doType;
begin
  _prop_Type := ToInteger(_Data);
end;

procedure THIGP_Curve._work_doFillMode;
begin
  _prop_FillMode := ToInteger(_Data);
end;

end.