unit hiGP_Label;

interface

uses Windows,Kol,Share,Debug,hiGP_Canvas,GDIPOBJ,GDIPAPI;

type
  THIGP_Label= class(TDebug)
   private
     FTabStop    :PStrListEx;
     ArrTabStop  :array of single;
     procedure SetTabStop(Value:PStrListEx);
   public
     _prop_Canvas:PICurrentCanvas;
     _prop_Caption:string;
     _prop_X:single;
     _prop_Y:single;
     _prop_Width:single;
     _prop_Hieght:single;
     _prop_Font:string;
     _prop_Size:single;
     _prop_Bold:boolean;
     _prop_Italic:boolean;
     _prop_Underline:boolean;
     _prop_Strikeout:boolean;
     _prop_LeftToRight:boolean;
     _prop_Vertical:boolean;
     _prop_NoFitBlackBox:boolean;
     _prop_DisplayFormatControl:boolean;
     _prop_NoFontFallback:boolean;
     _prop_MeasureTrailingSpaces:boolean;
     _prop_NoWrap:boolean;
     _prop_LineLimit:boolean;
     _prop_NoClip:boolean;
     _prop_AlignHorizontal:integer;
     _prop_AlignVertical:integer;
     _prop_Trimming:integer;
     _prop_HotKeyPrefix:integer;
     _prop_TabFirst:real;
     _prop_OutlineText:boolean;
     _prop_Frame:boolean;
     _prop_BrushBackground:string;
     _prop_PenFrame: string;
     _prop_BrushText:string;
     _prop_PenOutline: string;
          
     _data_Caption:THI_Event;
     _data_X:THI_Event;          
     _data_Y:THI_Event;
     _data_Width:THI_Event;
     _data_Hieght:THI_Event;
     _data_Font:THI_Event;  
     _data_Size:THI_Event;
     _data_Style:THI_Event; 
     _data_AlignHorizontal:THI_Event;
     _data_AlignVertical:THI_Event;
     _data_Trimming:THI_Event;
     _data_HotKeyPrefix:THI_Event;
     _data_TabFirst:THI_Event;
     _data_TabStops:THI_Event;     
     _data_BrushBackground:THI_Event; 
     _data_PenFrame:THI_Event;
     _data_BrushText:THI_Event;     
     _data_PenOutline:THI_Event;
     _event_onDraw: THI_Event;

     constructor Create;
     destructor Destroy; override;
     procedure _work_doDraw(var _Data:TData; Index:word);
     property _prop_TabStops:PStrListEx write SetTabStop;
  end;

implementation

constructor THIGP_Label.Create;
begin
   inherited Create;
   FTabStop := NewStrListEx; 
end;

destructor THIGP_Label.Destroy;
begin
   FTabStop .Free;
   inherited Destroy;
end;

procedure THIGP_Label.SetTabStop;
var i: integer;
begin
   FTabStop.Clear;
   FTabStop.Assign(Value);
   if FTabStop.Count = 0 then exit;
   SetLength(ArrTabStop, FTabStop.Count);
   for i := 0 to FTabStop.Count - 1 do begin
    ArrTabStop[i] := FTabStop.Objects[i] * 1.0;
   end;
end;

procedure THIGP_Label._work_doDraw;
var GPFont: TGPFont;
    Rect: TGPRectF;
    StringF: TGPStringFormat;
    Path: TGPGraphicsPath;
    FontFamily: TGPFontFamily; // ???
    Arr: PArray;
    Ind: TData;
    di: TData;
    size,x,y,w,h,TabFirst: single;
    i,sf,style:integer;
    font,iBrushTx,iBrushBg,str:string;
    Graphics:TGPGraphics;
begin
    if not Assigned(_prop_Canvas) then exit;
    Graphics := _prop_Canvas.Get_Canvas;
    str := ReadString(_data,_data_Caption,_prop_Caption);
    x := ReadReal(_data,_data_X,_prop_X);
    y := ReadReal(_data,_data_Y,_prop_Y);
    w := ReadReal(_data,_data_Width,_prop_Width);
    h := ReadReal(_data,_data_Hieght,_prop_Hieght);
    Rect := MakeRect(x,y,w,h);
    // 
    font := ReadString(_data,_data_Font,_prop_Font);    
    size := ReadReal(_data,_data_size,_prop_size);
    style := 0;
    if _prop_Bold then style := style + 1;
    if _prop_Italic then style := style + 2;
	if _prop_Underline then style := style + 4;
	if _prop_Strikeout then style := style + 8;
    style := Readinteger(_data,_data_Style, style);
	GPFont := TGPFont.Create(font, size, style);
    //  
    sf := 0;
    if _prop_LeftToRight then inc(sf,1);
    if _prop_Vertical then inc(sf,2);
    if _prop_NoFitBlackBox then inc(sf,4);
    if _prop_DisplayFormatControl then inc(sf,20);
    if _prop_NoFontFallback then inc(sf,400);
    if _prop_MeasureTrailingSpaces then inc(sf,800);
    if _prop_NoWrap then inc(sf,1000);
    if _prop_LineLimit then inc(sf,2000);
    if _prop_NoClip then inc(sf,4000);    
    StringF := TGPStringFormat.Create(sf);
    //   
    StringF.SetAlignment(TStringAlignment(ReadInteger(_data,_data_AlignHorizontal,_prop_AlignHorizontal)));
    //   
    StringF.SetLineAlignment(TStringAlignment(ReadInteger(_data,_data_AlignVertical,_prop_AlignVertical)));
    //  
    StringF.SetTrimming(TStringTrimming(ReadInteger(_data,_data_Trimming,_prop_Trimming)));
    //  &
    StringF.SetHotKeyPrefix(THotKeyPrefix(ReadInteger(_data,_data_HotKeyPrefix,_prop_HotKeyPrefix)));
    // 
    TabFirst := ReadReal(_data,_data_TabFirst,_prop_TabFirst);
    Arr := ReadArray(_data_TabStops);
    if Arr <> nil then begin
     if Arr._Count > 0 then begin
      SetLength(ArrTabStop, Arr._Count); 
      for i := 0 to Arr._Count - 1 do begin
       Ind := _DoData(i);
       Arr._Get(Ind,di);
       ArrTabStop[i] := ToReal(di);
      end;
     end;
    end; 
    StringF.SetTabStops(TabFirst,Length(ArrTabStop),pSingle(ArrTabStop));
    // 
    iBrushBg := ReadString(_data,_data_BrushBackground,_prop_BrushBackground);
    Graphics.FillRectangle(_prop_Canvas.Get_Brush((iBrushBg)),x,y,w,h);
    // 
    if _prop_Frame then Graphics.DrawRectangle(_prop_Canvas.Get_Pen(ReadString(_data,_data_PenFrame,_prop_PenFrame)),x,y,w,h);
    // 
    iBrushTx := ReadString(_data,_data_BrushText,_prop_BrushText);
    Graphics.DrawString(str,Length(str),GPFont,Rect,StringF,_prop_Canvas.Get_Brush(iBrushTx));
    //  
    if _prop_OutlineText then begin
     Path := TGPGraphicsPath.Create();
     FontFamily := TGPFontFamily.Create(font);
     Path.AddString(str, -1, FontFamily, 0, size, MakePoint(x, y), StringF);
     Graphics.DrawPath(_prop_Canvas.Get_Pen(ReadString(_data,_data_PenOutline,_prop_PenOutline)), Path);
     FontFamily.Free;
     Path.Free;
    end;
    StringF.Free;
    GPFont.Free;    
   _hi_CreateEvent(_Data,@_event_onDraw);
end;

end.
//Ver 1.1 08.05.2022
//add Font Style