unit hiGP_Matrix;

interface

uses Kol,Share,Debug,hiGP_Canvas,GDIPOBJ,GDIPAPI;

type
  THIGP_Matrix= class(TDebug)
   private
    procedure SetTransform;
   public
     _prop_Canvas:PICurrentCanvas;
     _prop_eM11:real;
     _prop_eM12:real;
     _prop_eM21:real;
     _prop_eM22:real;
     _prop_eDx:real;
     _prop_eDy:real;
     _prop_SetTransform:boolean;

     _data_eM11:THI_Event;
     _data_eM12:THI_Event;          
     _data_eM21:THI_Event;
     _data_eM22:THI_Event;  
     _data_eDx:THI_Event;  
     _data_eDy:THI_Event;     
     _event_onSet: THI_Event;
     _event_onReset: THI_Event;
     _event_onInvert: THI_Event;

     procedure _work_doSet(var _Data:TData; Index:word);
     procedure _work_doReset(var _Data:TData; Index:word);
     procedure _work_doInvert(var _Data:TData; Index:word);

  end;

implementation

procedure THIGP_Matrix.SetTransform;
var Graphics: TGPGraphics;
begin
    if _prop_SetTransform then
	 begin
	  Graphics :=  _prop_Canvas.Get_Canvas;
	  Graphics.SetTransform(_prop_Canvas.Get_Matrix);
	 end;
end;
procedure THIGP_Matrix._work_doSet;
var em11,em12,em21,em22,edx,edy: real;
    GPMatrix: TGPMatrix;
begin
    if not Assigned(_prop_Canvas) then exit;
    em11 := ReadReal(_data,_data_eM11,_prop_eM11);
    em12 := ReadReal(_data,_data_eM12,_prop_eM12);
    em21 := ReadReal(_data,_data_eM21,_prop_eM21);
    em22 := ReadReal(_data,_data_eM22,_prop_eM22);
    edx := ReadReal(_data,_data_edx,_prop_edx);
    edy := ReadReal(_data,_data_edy,_prop_edy);
    _prop_Canvas.Set_Matrix;
    GPMatrix := _prop_Canvas.Get_Matrix;
	GPMatrix.SetElements(em11,em12,em21,em22,edx,edy);
    SetTransform;
   _hi_CreateEvent(_Data,@_event_onSet);
end;

procedure THIGP_Matrix._work_doReset;
var GPMatrix: TGPMatrix;
begin
    if not Assigned(_prop_Canvas) then exit;
    GPMatrix := _prop_Canvas.Get_Matrix;
	GPMatrix.Reset;
    SetTransform;
    _hi_CreateEvent(_Data,@_event_onReset);
end;

procedure THIGP_Matrix._work_doInvert;
var GPMatrix: TGPMatrix;
begin
    if not Assigned(_prop_Canvas) then exit;
    GPMatrix := _prop_Canvas.Get_Matrix;
	GPMatrix.Invert;
    SetTransform;
   _hi_CreateEvent(_Data,@_event_onInvert);
end;


end.