unit hiGP_Pen;

interface

uses Windows,Kol,Share,Debug,hiGP_Canvas,GDIPOBJ,GDIPAPI;

type
  THIGP_Pen = class(TDebug)
   private
     FStartCap,FEndCap           :PStrList; 
     FDashArr,FCompoundArr       :PStrListEx;
     PointsStartCap,PointsEndCap :array of TGPPoint;
     CompoundArr,DashArr         :array of single;

     procedure SetCompound(Value:PStrListEx);
     procedure SetDashArr(Value:PStrListEx);
     procedure SetStartCapArr(Value:string);
     procedure SetEndCapArr(Value:string);
   public
     _prop_Canvas:PICurrentCanvas;
     _prop_TypeBrush:boolean;
     _prop_Color:integer;
     _prop_Alpha:integer;
     _prop_Size:single;
     _prop_Align:integer;
     _prop_StylePen:integer;
     _prop_DashOffset:integer;
     _prop_DashCap:integer;
     _prop_StartCap:integer;
     _prop_EndCap:integer;
     _prop_StartCapOffset:integer;
     _prop_EndCapOffset:integer;
     _prop_LineJoin:integer;
     _prop_MiterLimit:integer;
     _prop_Brush:string;
     _prop_Index: string;

     _data_Color:THI_Event;          
     _data_Alpha:THI_Event;
     _data_Size:THI_Event;
     _data_Align:THI_Event;
     _data_StylePen:THI_Event;
     _data_CustomStylePen:THI_Event;
     _data_DashOffset:THI_Event;    
     _data_DashCap:THI_Event;
     _data_StartCap:THI_Event;
     _data_EndCap:THI_Event;     
     _data_StartCapOffset:THI_Event;
     _data_EndCapOffset:THI_Event;   
     _data_Compound:THI_Event;
     _data_LineJoin:THI_Event;
     _data_MiterLimit:THI_Event;
     _data_Index:THI_Event;      
     _data_Brush:THI_Event;
     _event_onSet: THI_Event;
     
     constructor Create;
     destructor Destroy; override;    
     property _prop_CustomStylePen:PStrListEx write SetDashArr;
     property _prop_PointsStartCap:string write SetStartCapArr;
     property _prop_PointsEndCap:string write SetEndCapArr;     
     property _prop_Compound:PStrListEx write SetCompound;
     procedure _work_doSet(var _Data:TData; Index:word);
  end;

implementation

constructor THIGP_Pen.Create;
begin
   inherited Create;
   FStartCap := NewStrList;
   FEndCap := NewStrList;   
   FDashArr := NewStrListEx;  
   FCompoundArr := NewStrListEx; 
end;

destructor THIGP_Pen.Destroy;
begin
   FDashArr.Free;
   FStartCap.Free;
   FEndCap.Free;   
   FCompoundArr.Free;
   inherited Destroy;
end;

procedure THIGP_Pen.SetDashArr;
var i: integer;
begin
   FDashArr.Clear;
   FDashArr.Assign(Value);
   if FDashArr.Count = 0 then exit;
   SetLength(DashArr, FDashArr.Count);
   for i := 0 to FDashArr.Count - 1 do begin
    DashArr[i] := FDashArr.Objects[i];
   end;
end;

procedure THIGP_Pen.SetStartCapArr;
var str: string;
    i:integer;
begin
   FStartCap.SetText(Value, false);
   SetLength(PointsStartCap, FStartCap.Count);
   for i := 0 to FStartCap.Count - 1 do begin
    str := FStartCap.Items[i];
     PointsStartCap[i].X := str2int(GetTok(str,';'));
     PointsStartCap[i].Y := str2int(GetTok(str,';'));
   end;
end;

procedure THIGP_Pen.SetEndCapArr;
var str: string;
    i:integer;
begin
   FEndCap.SetText(Value, false);
   SetLength(PointsEndCap, FEndCap.Count);
   for i := 0 to FEndCap.Count - 1 do begin
    str := FEndCap.Items[i];
     PointsEndCap[i].X := str2int(GetTok(str,';'));
     PointsEndCap[i].Y := str2int(GetTok(str,';'));
   end;
end;

procedure THIGP_Pen.SetCompound;
var i: integer;
begin
   FCompoundArr.Clear;
   FCompoundArr.Assign(Value);
   if FCompoundArr.Count = 0 then exit;
   SetLength(CompoundArr, FCompoundArr.Count);
   for i := 0 to FCompoundArr.Count - 1 do begin
    CompoundArr[i] := FCompoundArr.Objects[i] / 100;
   end;
end;

procedure THIGP_Pen._work_doSet;
var   di: TData;
      Arr: PArray;
      Ind: TData;
      fFrom: TRGB;
      StrokePath:TGPGraphicsPath;
      GPCustomLineCap:TGPCustomLineCap;
      Types: array of TPathPointType;
      iPen,iBrush: string;
      scap,ecap,pstyle,i:integer;
begin
   if not Assigned(_prop_Canvas) then exit;
   iPen := ReadString(_data,_data_Index,_prop_Index);
   iBrush := ReadString(_data,_data_Brush,_prop_Brush);
   fFrom := TRGB(Color2RGB(ReadInteger(_Data, _data_Color, _prop_Color)));
   //          
   if _prop_TypeBrush then _prop_Canvas.Set_Pen(TGPPen.Create(_prop_Canvas.Get_Brush(iBrush)),iPen)
    else _prop_Canvas.Set_Pen(TGPPen.Create(MakeColor(ReadInteger(_data,_data_Alpha,_prop_Alpha), FFrom.R, FFrom.G, FFrom.B)),iPen);
   //  
   _prop_Canvas.Get_Pen(iPen).SetWidth(ReadReal(_Data,_data_Size,_prop_Size));
   // 
   if 1 = ReadInteger(_Data,_data_Align,_prop_Align) then _prop_Canvas.Get_Pen(iPen).SetAlignment(PenAlignmentInset);
   //_prop_Canvas.Get_Pen(iPen).SetAlignment(PenAlignmentInset);//PenAlignmentInset //PenAlignmentCenter
   //  
   pstyle := ReadInteger(_Data,_data_StylePen,_prop_StylePen);
   //   
   if pstyle = 5 then begin
    Arr := ReadArray(_data_CustomStylePen);
    if Arr <> nil then begin
     if (Arr._Count > 0) then begin
      SetLength(DashArr, Arr._Count); 
      for i := 0 to Arr._Count - 1 do begin
       Ind := _DoData(i);
       Arr._Get(Ind,di);
       DashArr[i] := ToInteger(di);
      end;
     end;
    end;
    _prop_Canvas.Get_Pen(iPen).SetDashPattern(pSingle(DashArr),Length(DashArr)); 
   end;
   //  
   _prop_Canvas.Get_Pen(iPen).SetDashStyle(TDashStyle(pstyle)); 
   //   
   _prop_Canvas.Get_Pen(iPen).SetDashOffset(ReadInteger(_Data, _data_DashOffset, _prop_DashOffset));
   //   
   case ReadInteger(_data,_data_DashCap,_prop_DashCap) of
    0: _prop_Canvas.Get_Pen(iPen).SetDashCap(0);  //
    1: _prop_Canvas.Get_Pen(iPen).SetDashCap(2);  //
    2: _prop_Canvas.Get_Pen(iPen).SetDashCap(3);  //
   end;
   //  
   scap := ReadInteger(_Data,_data_StartCap,_prop_StartCap);
   _prop_Canvas.Get_Pen(iPen).SetStartCap(TLineCap(scap));
   //   
   if (scap = 9)  and (Length(PointsStartCap) <> 0) then begin
    SetLength(Types, Length(PointsStartCap));
    Types[0] := 0;
    Types[Length(PointsStartCap) - 1] := $81;
    for i := 1 to Length(PointsStartCap) - 2 do begin
      Types[i] := 1;
    end;
    StrokePath := TGPGraphicsPath.Create(PGPPoint(PointsStartCap),pByte(Types),Length(PointsStartCap));
    GPCustomLineCap := TGPCustomLineCap.Create(nil,StrokePath,LineCapFlat,ReadInteger(_Data,_data_StartCapOffset,_prop_StartCapOffset));
    _prop_Canvas.Get_Pen(iPen).SetCustomStartCap(GPCustomLineCap);
    GPCustomLineCap.Free;
    StrokePath.Free;
   end; 
   //  
   ecap := ReadInteger(_Data,_data_EndCap,_prop_EndCap);
   _prop_Canvas.Get_Pen(iPen).SetEndCap(TLineCap(ecap));
   //   
   if (ecap = 9) and (Length(PointsEndCap) <> 0) then begin
    SetLength(Types, Length(PointsEndCap));
    Types[0] := 0;
    Types[Length(PointsEndCap) - 1] := $81;
    for i := 1 to Length(PointsEndCap) - 2 do begin
      Types[i] := 1;
    end;
    StrokePath := TGPGraphicsPath.Create(PGPPoint(PointsEndCap),pByte(Types),Length(PointsEndCap));
    GPCustomLineCap := TGPCustomLineCap.Create(nil,StrokePath,LineCapFlat,ReadInteger(_Data,_data_EndCapOffset,_prop_EndCapOffset));
    _prop_Canvas.Get_Pen(iPen).SetCustomEndCap(GPCustomLineCap);
    GPCustomLineCap.Free;
    StrokePath.Free;
   end; 
   //  
    Arr := ReadArray(_data_Compound);
    if Arr <> nil then begin
     if (Arr._Count > 0) then begin
      SetLength(CompoundArr, Arr._Count); 
      for i := 0 to Arr._Count - 1 do begin
       Ind := _DoData(i);
       Arr._Get(Ind,di);
       CompoundArr[i] := ToInteger(di) / 100;
      end;
     end;
    end; 
   if Length(CompoundArr) <> 0 then _prop_Canvas.Get_Pen(iPen).SeTCompoundArray(pSingle(CompoundArr), Length(CompoundArr)); 
   //    
   _prop_Canvas.Get_Pen(iPen).SetLineJoin(TLineJoin(ReadInteger(_data,_data_LineJoin,_prop_Linejoin)));
   //  
   _prop_Canvas.Get_Pen(iPen).SetMiterLimit(ReadInteger(_data,_data_MiterLimit,_prop_MiterLimit) / 10.0);
   _hi_CreateEvent(_Data,@_event_onSet);

end;

end.