unit hiGP_PolyLine;

interface

uses Kol,Share,Debug,hiGP_Canvas,GDIPOBJ,GDIPAPI;

type
  THIGP_PolyLine = class(TDebug)
   private
     Item:TData;
     FPoints:PStrList; 
     Points: array of TGPPointF;
     procedure WritePoints;
     procedure SetPoints(Value:string);
   public
     _prop_Canvas:PICurrentCanvas;
     _prop_Pen: string;
               
     _data_PointsArray:THI_Event;
     _data_Pen:THI_Event;
     _event_onDraw: THI_Event;
     
     constructor Create;
     destructor Destroy; override;    
     property _prop_PointsArray:string write SetPoints;
     procedure _work_doDraw(var _Data:TData; Index:word);
  end;

implementation

constructor THIGP_PolyLine.Create;
begin
   inherited Create;
   FPoints := NewStrList;
end;

destructor THIGP_PolyLine.Destroy;
begin
   FPoints.Free;
   inherited Destroy;
end;

procedure THIGP_PolyLine.WritePoints;
var str: string;
    i:integer;
begin
   SetLength(Points, FPoints.Count);
   for i := 0 to FPoints.Count - 1 do begin
    str := FPoints.Items[i];
     points[i].X := str2Double(GetTok(str,';'));
     points[i].Y := str2Double(GetTok(str,';'));
   end;
end;

procedure THIGP_PolyLine.SetPoints;
begin
   FPoints.SetText(Value, false);
   WritePoints;
end;

procedure THIGP_PolyLine._work_doDraw;
var iPen:string;
    i:integer;
    Arr:PArray;
    Ind,dt:TData;
    d:PData;
    Graphics:TGPGraphics;
begin
    if not Assigned(_prop_Canvas) then exit;
    Graphics := _prop_Canvas.Get_Canvas;
    Arr := ReadArray(_data_PointsArray);
    if (Arr <> nil) and (Arr._Count > 0)then begin
     SetLength(points, Arr._Count); 
     for i := 0 to Arr._Count - 1 do begin
       dtInteger(Ind,i);
       Arr._Get(Ind,Item);
       d := @Item;  
       dtData(dt, d^);
       d := d.ldata; 
       points[i].X := toReal(dt);
       dtData(dt, d^);
       points[i].Y := toReal(dt);
      end;
      FreeData(@Item);
     end;
   iPen := ReadString(_data,_data_Pen,_prop_Pen);
   Graphics.DrawLines(_prop_Canvas.Get_Pen(iPen), PGPPointF(points),Length(points));
   _hi_CreateEvent(_Data,@_event_onDraw);
end;

end.