unit hiGP_Polygon;

interface

uses Kol,Share,Debug,hiGP_Canvas,GDIPOBJ,GDIPAPI;

type
  THIGP_Polygon= class(TDebug)
   private
     Item:TData;
     FPoints:PStrList; 
     Points: array of TGPPointF;
     procedure SetPoints(Value:string);
   public
     _prop_Canvas:PICurrentCanvas;
     _prop_View:integer;
     _prop_FillMode:integer;
     _prop_Pen: string;
     _prop_Brush:string;     
               
     _data_ArrayXY:THI_Event;
     _data_Pen:THI_Event;
     _data_Brush:THI_Event;
     _event_onDraw: THI_Event;
     
     constructor Create;
     destructor Destroy; override;    
     property _prop_PointsArray:string write SetPoints;
     procedure _work_doDraw(var _Data:TData; Index:word);
     procedure _work_doFillMode(var _Data:TData; Index:word);
     procedure _work_doView(var _Data:TData; Index:word);
  end;

implementation

constructor THIGP_Polygon.Create;
begin
   inherited Create;
   FPoints := NewStrList;
end;

destructor THIGP_Polygon.Destroy;
begin
   FPoints.Free;
   inherited Destroy;
end;

procedure THIGP_Polygon.SetPoints;
var str: string;
    i:integer;
begin
   FPoints.SetText(Value, false);
   SetLength(points, FPoints.Count);
   for i := 0 to FPoints.Count - 1 do begin
    str := FPoints.Items[i];
     points[i].X := str2int(GetTok(str,';'));
     points[i].Y := str2int(GetTok(str,';'));
   end;
end;

procedure THIGP_Polygon._work_doDraw;
var  i: integer;
     iPen,iBrush: string;
     Arr:PArray;
     Ind,dt:TData;
     d:PData;
     Graphics: TGPGraphics;
begin
     if not Assigned(_prop_Canvas) then exit;
	 Graphics := _prop_Canvas.Get_Canvas; 
     Arr := ReadArray(_data_ArrayXY);
     if (Arr <> nil) and (Arr._Count > 0)then begin
      SetLength(points, Arr._Count); 
      for i := 0 to Arr._Count - 1 do begin
       dtInteger(Ind,i);
       Arr._Get(Ind,Item);
       d := @Item;  
       dtData(dt, d^);
       d := d.ldata; 
       points[i].X := toReal(dt);
       dtData(dt, d^);
       points[i].Y := toReal(dt);
      end;
      FreeData(@Item);
     end;
    iPen := ReadString(_data,_data_Pen,_prop_Pen);
    iBrush := ReadString(_data,_data_Brush,_prop_Brush);
    case _prop_View of
     0: Graphics.DrawPolygon(_prop_Canvas.Get_Pen(iPen),PGPPointF(points),Length(points));
     1: Graphics.FillPolygon(_prop_Canvas.Get_Brush(iBrush),PGPPointF(points),Length(points),FillMode(_prop_FillMode));
     2: begin
         Graphics.FillPolygon(_prop_Canvas.Get_Brush(iBrush),PGPPointF(points),Length(points),FillMode(_prop_FillMode));
         Graphics.DrawPolygon(_prop_Canvas.Get_Pen(iPen),PGPPointF(points),Length(points));
        end;
     end;
   _hi_CreateEvent(_Data,@_event_onDraw);
end;

procedure THIGP_Polygon._work_doFillMode;
begin
  _prop_FillMode := ToInteger(_Data);
end;

procedure THIGP_Polygon._work_doView;
begin
  _prop_View := ToInteger(_Data);
end;

end.