unit hiGP_Rotate;

interface

uses Kol,Share,Debug,hiGP_Canvas,GDIPOBJ,GDIPAPI;

type
  THIGP_Rotate= class(TDebug)
   private
   public
     _prop_Canvas:PICurrentCanvas;
     _prop_angle:real;     
     _prop_X:integer;
     _prop_Y:integer;
     _prop_MatrixOrder:integer;
     _prop_SetTransform:boolean;

     _data_angle:THI_Event;  
     _data_X:THI_Event;  
     _data_Y:THI_Event;     
     _data_MatrixOrder:THI_Event;
     _event_onRotate: THI_Event;
     _event_onRotateAt: THI_Event;

     procedure _work_doRotate(var _Data:TData; Index:word);
     procedure _work_doRotateAt(var _Data:TData; Index:word);

  end;

implementation

procedure THIGP_Rotate._work_doRotate;
var GPMatrix:TGPMatrix;
	Graphics:TGPGraphics;
begin
    if not Assigned(_prop_Canvas) then exit;
    _prop_Canvas.Set_Matrix;
    GPMatrix := _prop_Canvas.Get_Matrix;
	GPMatrix.Rotate(ReadReal(_data,_data_angle,_prop_angle),TMatrixOrder(ReadInteger(_data,_data_MatrixOrder,_prop_MatrixOrder)));
    if _prop_SetTransform then
	  begin
	    Graphics := _prop_Canvas.Get_Canvas;
		Graphics.SetTransform(_prop_Canvas.Get_Matrix);
      end;
   _hi_CreateEvent(_Data,@_event_onRotate);
end;


procedure THIGP_Rotate._work_doRotateAt;
var x,y,angle:real;
    GPMatrix:TGPMatrix;
	Graphics:TGPGraphics;
begin
    if not Assigned(_prop_Canvas) then exit;
    angle := ReadReal(_data,_data_angle,_prop_angle);
    X := ReadInteger(_data,_data_X,_prop_X);
    Y := ReadInteger(_data,_data_Y,_prop_Y);
    _prop_Canvas.Set_Matrix;
    GPMatrix := _prop_Canvas.Get_Matrix;
	GPMatrix.RotateAt(angle,MakePoint(X,Y),TMatrixOrder(ReadInteger(_data,_data_MatrixOrder,_prop_MatrixOrder)));
    if _prop_SetTransform then
	  begin
	    Graphics := _prop_Canvas.Get_Canvas;
	    Graphics.SetTransform(_prop_Canvas.Get_Matrix);
      end;
   _hi_CreateEvent(_Data,@_event_onRotateAt);
end;

end.