unit hiGP_Ruler;

interface

uses Kol,Share,Debug,hiGP_Canvas,GDIPOBJ,GDIPAPI;

type
  THIGP_Ruler= class(TDebug)
   private
   public
     _prop_Canvas:PICurrentCanvas;
     _prop_PageUnit:integer;
     _prop_PageScale:real;

     _data_PageUnit:THI_Event;  
     _data_PageScale:THI_Event;     
     _event_onSetPageUnit: THI_Event;
     _event_onSetPageScale: THI_Event;

     procedure _work_doSetPageUnit(var _Data:TData; Index:word);
     procedure _work_doSetPageScale(var _Data:TData; Index:word);
     procedure _var_GetPageUnit(var _Data:TData; Index:word); 
     procedure _var_GetPageScale(var _Data:TData; Index:word); 
  end;

implementation

procedure THIGP_Ruler._work_doSetPageUnit;
var Graphics: TGPGraphics;
begin
    if not Assigned(_prop_Canvas) then exit;
    Graphics := _prop_Canvas.Get_Canvas;
	Graphics.SetPageUnit(TUnit(ReadInteger(_data,_data_PageUnit,_prop_PageUnit)));
    _hi_CreateEvent(_Data,@_event_onSetPageUnit);
end;

procedure THIGP_Ruler._work_doSetPageScale;
var Graphics: TGPGraphics;
begin
    if not Assigned(_prop_Canvas) then exit;
    Graphics := _prop_Canvas.Get_Canvas;
	Graphics.SetPageScale(ReadReal(_data,_data_PageScale,_prop_PageScale));
    _hi_CreateEvent(_Data,@_event_onSetPageScale);
end;

procedure THIGP_Ruler._var_GetPageUnit;
var pgunit:TUnit;
    x: integer;
    Graphics: TGPGraphics;
begin
    if not Assigned(_prop_Canvas) then exit;
    x := 0;
    Graphics := _prop_Canvas.Get_Canvas;
    pgunit := Graphics.GetPageUnit;
    case pgunit of
     UnitWorld: x := 0;
     UnitDisplay: x := 1;
     UnitPixel: x := 2;
     UnitPoint: x := 3;
     UnitInch: x := 4;
     UnitDocument: x := 5;
     UnitMillimeter: x := 6;
    end;
    dtInteger(_data,x);
end;

procedure THIGP_Ruler._var_GetPageScale;
var Graphics: TGPGraphics;
begin
    if not Assigned(_prop_Canvas) then exit;
    Graphics := _prop_Canvas.Get_Canvas;
    dtReal(_data,Graphics.GetPageScale);
end;


end.