unit hiGP_Text;

interface

uses Kol,Share,Debug,hiGP_Canvas,GDIPOBJ,GDIPAPI;

type
  THIGP_Text= class(TDebug)
   private
   public    
     _prop_Canvas:PICurrentCanvas;
     _prop_Text:string;
     _prop_X:single;
     _prop_Y:single;
     _prop_Font:string;
     _prop_Size:single;
     _prop_Bold:boolean;
     _prop_Italic:boolean;
     _prop_Underline:boolean;
     _prop_Strikeout:boolean;
     _prop_Brush:string;

     _data_Text:THI_Event;
     _data_X:THI_Event;          
     _data_Y:THI_Event;
     _data_Font:THI_Event;  
     _data_Size:THI_Event;
     _data_Style:THI_Event;    
     _data_Brush:THI_Event;     
     _event_onDraw: THI_Event;

     function GetStyle:integer;
	 procedure _work_doDraw(var _Data:TData; Index:word);
     procedure _var_TextWidth(var _Data:TData; Index:word);
     procedure _var_TextHeight(var _Data:TData; Index:word);
  end;

implementation

function THIGP_Text.GetStyle;
begin
    Result := 0;
    if _prop_Bold then Result := Result + 1;
    if _prop_Italic then Result := Result + 2;
	if _prop_Underline then Result := Result + 4;
	if _prop_Strikeout then Result := Result + 8;
end;


procedure THIGP_Text._work_doDraw;
var GPFont: TGPFont;
	style: integer;
	size,x,y: single;
    font,iBrush,str: string;
    Graphics:TGPGraphics;
begin
	if not Assigned(_prop_Canvas) then exit;
	Graphics := _prop_Canvas.Get_Canvas;
    str := ReadString(_data,_data_Text,_prop_Text);
    x := ReadReal(_data,_data_X,_prop_X);
    y := ReadReal(_data,_data_Y,_prop_Y);
    font := ReadString(_data,_data_Font,_prop_Font);    
    size := ReadReal(_data,_data_size,_prop_size);
    iBrush := ReadString(_data,_data_Brush,_prop_Brush);
    style := Readinteger(_data,_data_Style, GetStyle);
	GPFont := TGPFont.Create(font, size, style);
	Graphics.DrawString(str,Length(str),GPFont,MakePoint(x,y),_prop_Canvas.Get_Brush(iBrush));
    GPFont.Free;    
   _hi_CreateEvent(_Data,@_event_onDraw);
end;

procedure THIGP_Text._var_TextWidth;
var GPFont: TGPFont;
    style: integer;
    size,x,y: single;
    font,str: string;
    boxsize: TGPRectF;
    Graphics:TGPGraphics;
begin
    if not Assigned(_prop_Canvas) then exit;
    Graphics := _prop_Canvas.Get_Canvas;
    str := ReadString(_data,_data_Text,_prop_Text);
    x := ReadReal(_data,_data_X,_prop_X);
    y := ReadReal(_data,_data_Y,_prop_Y);
    font := ReadString(_data,_data_Font,_prop_Font);    
    size := ReadReal(_data,_data_size,_prop_size);
    style := Readinteger(_data,_data_Style, GetStyle);
	GPFont := TGPFont.Create(font, size, style);
    Graphics.MeasureString(str,-1,GPFont,MakePoint(x,y),boxsize);
    GPFont.Free;
    dtInteger(_Data, Round(boxsize.width));
end;

procedure THIGP_Text._var_TextHeight;
var GPFont: TGPFont;
    style: integer;
    size,x,y: single;
    font,str: string;
    boxsize: TGPRectF;
    Graphics:TGPGraphics;
begin
    if not Assigned(_prop_Canvas) then exit;
    Graphics := _prop_Canvas.Get_Canvas;
    str := ReadString(_data,_data_Text,_prop_Text);
    x := ReadReal(_data,_data_X,_prop_X);
    y := ReadReal(_data,_data_Y,_prop_Y);
    font := ReadString(_data,_data_Font,_prop_Font);    
    size := ReadReal(_data,_data_size,_prop_size);
    style := Readinteger(_data,_data_Style, GetStyle);
	GPFont := TGPFont.Create(font, size, style);
    Graphics.MeasureString(str,-1,GPFont,MakePoint(x,y),boxsize);
    GPFont.Free;
    dtInteger(_Data, Round(boxsize.height));
end;
end.
//Ver 1.1 08.05.2022
//add Font Style
